
# Vampyr`s Corp presents:
# ProvAdmin - procs
#
# (C) 2009, Igor Muraviov
# Based on NetBilling, Michael Klimenko
#
# $Revision: 2.9 $
#

# ABSOLUTE path for NetBilling configuration file
#     
my $config_file = "/Base/provadmin/etc/provadmin.conf";


###################################################################################
###################################################################################
###################################################################################

use Sys::Syslog;
use Time::Local;
use Digest::MD5 qw(md5_base64);

#   
open(F, $config_file) || die "Can't open $config_file\n";
while(<F>) {
    next if (/^#/);
    if (/^(\S+)\s+(.+)$/) {
	${$1} = $2;
    }
}
close(F);
#    
$language = $default_language;
#   
open(F, $languagedir.$language) || die "Can't open ${languagedir}$language\n";
while(<F>) {
    next if (/^#/);
    if (/^(\S+)=(.+)$/) {
        $lang{$1} = $2;
	$lang{$1} =~ s/\\n/\n/g;
    }
}
close(F);


#    
@mask_const = (
0x00000000,0x80000000,0xC0000000,0xE0000000,0xF0000000,0xF8000000,0xFC000000,0xFE000000,
0xFF000000,0xFF800000,0xFFC00000,0xFFE00000,0xFFF00000,0xFFF80000,0xFFFC0000,0xFFFE0000,
0xFFFF0000,0xFFFF8000,0xFFFFC000,0xFFFFE000,0xFFFFF000,0xFFFFF800,0xFFFFFC00,0xFFFFFE00,
0xFFFFFF00,0xFFFFFF80,0xFFFFFFC0,0xFFFFFFE0,0xFFFFFFF0,0xFFFFFFF8,0xFFFFFFFC,0xFFFFFFFE,0xFFFFFFFF
);

#  
@monthnames = ('',$lang{MON_JAN},$lang{MON_FEB},$lang{MON_MAR},$lang{MON_APR},$lang{MON_MAY},$lang{MON_JUN},
	          $lang{MON_JUL},$lang{MON_AUG},$lang{MON_SEP},$lang{MON_OCT},$lang{MON_NOV},$lang{MON_DEC});

#     
@monthrnames = ('',$lang{MONR_JAN},$lang{MONR_FEB},$lang{MONR_MAR},$lang{MONR_APR},$lang{MONR_MAY},$lang{MONR_JUN},
                   $lang{MONR_JUL},$lang{MONR_AUG},$lang{MONR_SEP},$lang{MONR_OCT},$lang{MONR_NOV},$lang{MONR_DEC});

@user_rights = ( 'User', 'Manager', 'Admin' );

@bukoff_rus = ('','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
# (30)
@bukoff_eng = ('A','B','C','D','E','F','G','H','I','J','K','L','M','N','O','P','Q','R','S','T','U','V','W','X','Y','Z');
#ABCDEFGHIJKLMNOPQRSTUVWXYZ (26)

#  
my $version = '3.1.01';
###################################################################################

#   HTML
sub html_start($)
{
    my $msg = shift;
    print "Content-type: text/html; charset=\"$lang{ENCODING}\"\n\n";
    print "<HTML><HEAD><META HTTP-EQUIV=Content-Type CONTENT=text/html; charset=$lang{ENCODING}>\n";
    print "<META http-equiv=\"Expires\" content=\"Tue, 20 Aug 1996 0:00:00 GMT\">\n";
    print "<TITLE>ProvAdmin v$version - $msg</TITLE></HEAD>";
    print "<STYLE type=text/css>\n";
    print "  BODY { font-family: Tahoma; font-size: 12px; color:#000000; background-color: #dfefff; margin-left:10px; margin-right:10px; margin-top:3px; margin-bottom:0px;}\n";
    print "  A { color:#225588; }\n";
    print "  TABLE { font-family: Tahoma; font-size: 12px; }\n";
    print "  TR { font-family: Tahoma; font-size: 12px; }\n";
    print "  TD { font-family: Tahoma; font-size: 12px; }\n";
    print "  .btbl { border-color: #4fafaf;  border-width: 1px; }\n";
    print "  A.atbl { color: #000030; text-decoration: none; }\n";
    print "  A.ctbl { text-decoration: none; }\n";
    print "  table.sort{\n";
    print "  border-spacing:0.1em;\n";
#    print "  margin-bottom:1em;\n";
#    print "  margin-top:1em\n";
    print "  }\n";
    print "  table.sort td{\n";
#    print "  border:1px solid #CCCCCC;\n";
#    print "  padding:0.3em 1em\n";
    print "  }\n";
    print "  table.sort thead td{\n";
    print "  cursor:pointer;\n";
    print "  cursor:hand;\n";
    print "  font-weight:bold;\n";
    print "  text-align:center;\n";
    print "  vertical-align:middle\n";
    print "  }\n";
    print "  table.sort thead td.curcol{\n";
    print "  background-color:#999999;\n";
    print "  color:#FFFFFF\n";
    print "  }\n";
    print "</STYLE>\n";
    print "<BODY>\n";
}

#   HTML
sub html_end()
{
    print "<DIV align=center><hr><FONT size=-1 face=arial,tahoma,verdana>\n";
    print "<A STYLE=\"text-decoration:none;color:#000000\" href=\"http://forum.provadmin.spb.ru\" target=_blank>ProvAdmin v$version</A><br>\n";
    print "<form><input type=\"button\" value=\"(C) 2009, Igor Muraviov\" onClick=location.href=\"mailto:igor\@vampyr.msk.ru\"></form>\n";
    print "</FONT></DIV>\n";
    print "</BODY></HTML>\n";
}

#   
sub print_navmenu($$)
{
    (my $user, my $status) = @_;

    print "<div align=center><table border='0' width=100%>\n";
    print "<tr><td><DIV align=left>[&nbsp;";
    print "<A href=$spath_log?user=$user>$lang{MODNAME_LOG}</A>&nbsp;|&nbsp;\n";
    if ( $status > 0 )
	{ print "<A href=$spath_stat?user=$user>$lang{MODNAME_STAT}</A>&nbsp;|&nbsp;\n"; }
    print "<A href=$spath_income?user=$user>$lang{MODNAME_INCOME}</A>&nbsp;|&nbsp;\n";
    print "<A href=$spath_outlay?user=$user>$lang{MODNAME_OUTLAY}</A>&nbsp;|&nbsp;\n";
    if ( $status > 0 )
	{ print "<A href=$spath_cards?user=$user>$lang{MODNAME_CARDS}</A>&nbsp;|&nbsp;\n" if ($cards_needed); }
    print "<A href=$spath_zones?user=$user>$lang{MODNAME_ZONES}</A>&nbsp;|&nbsp;\n";
    if ( $status > 1 )
	{
	print "<A href=$spath_ifaces?user=$user>$lang{MODNAME_IFACES}</A>&nbsp;|&nbsp;\n";
	print "<A href=$spath_hard?user=$user>$lang{MODNAME_HARD}</A>&nbsp;|&nbsp;\n";
	print "<A href=$spath_diag?user=$user>$lang{MODNAME_DIAG}</A>&nbsp;|&nbsp;\n";
	}
    print "<A href=$spath_clients?user=$user>$lang{MODNAME_CLIENTS}</A>\n";
    if ( $status > 1 )
	{ print "&nbsp;|&nbsp;<A href=$spath_users?user=$user>$lang{MODNAME_USERS}</A>\n"; }
    else
	{ print "&nbsp;|&nbsp;<A href=$spath_users?Action=profile&user=$user>$lang{MODNAME_PROFILE}</A>\n"; }
    print "&nbsp;]</DIV></td><td align=right>\n";
    print "<DIV align=right>[&nbsp;";
    print "<A href=$spath_index?Action=logout&out=$user>$lang{MODNAME_OUT}</A>&nbsp;";
    print "&nbsp;]</DIV></td></tr></table>";
}

#  IP    
sub ipnum2str($)
{
    my $num = shift;
    my $res = '';
    $res .= ($num & 0xFF000000) >> 24;
    $res .= '.';
    $res .= ($num & 0x00FF0000) >> 16;
    $res .= '.';
    $res .= ($num & 0x0000FF00) >> 8;
    $res .= '.';
    $res .= ($num & 0x000000FF);
    return $res;
}

#  IP    
sub ipstr2num($)
{
    my $str = shift;
    my $res = 0;
    $str =~ /(\d{1,3})\.(\d{1,3})\.(\d{1,3})\.(\d{1,3})/;
    $res = ($1 << 24) + ($2 << 16) + ($3 << 8) + $4;
    return $res;
}

sub select_status($$$)
{
    (my $name, my $current, my $status) = @_;
    my $end = @user_rights;
    if ( $status < 3 )
        { $end = $status+1; }
    print "<SELECT NAME=$name>";
    for ( my $i=0; $i < $end; $i++ )
        { print "<OPTION VALUE=$i" . (($user_rights[$i] eq $current) ? " SELECTED" : "") . ">$user_rights[$i]"; }
    print "</SELECT>\n";
}

#     
sub get_date()
{
    (my $sec,my $min,my $hour,my $mday,my $mon,my $year,my $wday,my $yday,my $isdst) = localtime(time);
    return sprintf("%02d:%02d:%02d %02d.%02d.%4d",$hour,$min,$sec,$mday,$mon+1,$year+1900);
}

sub send_mail($$$$$)
{
    (my $mail_text, my $mail_from, my $mail_to, my $subj, my $mail_end) = @_;


    open(MAIL,"| $mailprog $mailflags"); 
    print MAIL "From: $mail_from\n"; 
    print MAIL "To: $mail_to\n"; 
    print MAIL "Subject: $subj\n"; 
    print MAIL "Content-Type: text/plain; charset=$lang{ENCODING}\nContent-Transfer-Encoding: 8bit\n\n\n";
    print MAIL "$mail_text\n\n\n";
    print MAIL "$mail_end\n\n\n";
    close(MAIL);
}

#    
sub log_msg($)
{
    my $msg = shift;
    if (defined $syslogfacility) {
        openlog('netbill', 'pid', $syslogfacility);
    } else {
        openlog('netbill', 'pid', 'user');
    }
    syslog('info', $msg);
    closelog();

}

#      
sub log_user_event($$$)
{
    (my $dbh, my $cid, my $msg) = @_;
    eval { $dbh->do("INSERT INTO Log VALUES ($cid,NOW(),".$dbh->quote($msg).")"); };

    if ($@) { print "   Log: $@<br>";}

    my $sth;
    eval { $sth=$dbh->prepare("SELECT Email,SendMail FROM Users ");$sth->execute(); };
    if ($@) {print "<FONT color=red>     ($@).</FONT><br>"; log_msg("     ($@).");};
    while ( my $ref=$sth->fetchrow_hashref())
	{
	if ( ($ref->{'SendMail'} == 1 || $ref->{'SendMail'} == 2) && $ref->{'Email'} ne '' )
	    { send_mail($msg, $mailfrom, $ref->{'Email'}, "Event from $orgtitle", ''); }
	}
}

##################################################################################

#     
sub add_money($$$)
{
    (my $dbh, my $cid, my $sum) = @_;
    if ($sum <= 0) { return; };
    eval { $dbh->do("UPDATE Client SET Credit=(Credit+$sum) WHERE ID=$cid") };
    if ($@) {print "<FONT color=red>    ($@).</FONT><br>";return;};
    #   
    eval { $dbh->do("INSERT INTO Income VALUES ($cid,NOW(),$sum)") };
    if ($@) {print "<FONT color=red>     ($@).</FONT><br>"};
}



sub select_day($$)
{
    (my $name, my $currentday) = @_;
    print "<SELECT NAME=$name>";
    for (my $i=1; $i<=31; $i++) {
        print "<OPTION VALUE=$i" . (($i==$currentday) ? " SELECTED" : "") . ">$i";
        }    
    print "</SELECT>\n";
}


sub select_month($$)
{
    (my $name, my $currentmonth) = @_;
    print "<SELECT NAME=$name>";
    for (my $i=1; $i<=12; $i++) {
        print "<OPTION VALUE=$i" . (($i==$currentmonth) ? " SELECTED" : "") . ">$monthnames[$i]";
        }    
    print "</SELECT>\n";
}

sub select_year($$$$)
{
    (my $name, my $startyear, my $endyear, my $f) = @_;
    print "<SELECT NAME=$name>";
    for ($y=$startyear; $y<=$endyear; $y++) {
    if ($f==0 && $y==$startyear) {
        print "<OPTION VALUE=$y SELECTED>$y";
	} elsif ($f==1 && $y==$endyear) {
        print "<OPTION VALUE=$y SELECTED>$y";
	} else {
	    print "<OPTION VALUE=$y>$y";
    	}
    }
    print "</SELECT>\n";
}

sub select_hour($$)
{
    (my $name, my $currenthour) = @_;
    print "<SELECT NAME=$name>\n";
    for (my $i=0; $i<=23; $i++) {
        print "<OPTION VALUE=$i" . (($i==$currenthour) ? " SELECTED" : "") . ">$i\n";
        }    
    print "</SELECT>\n";
}

sub select_min($$)
{
    (my $name, my $currentmin) = @_;
    print "<SELECT NAME=$name\n>";
#    print "<OPTION VALUE='-'> -" ;
    for (my $i=0; $i<=59; $i++) {
        print "<OPTION VALUE=$i" . (($i==$currentmin) ? " SELECTED" : "") . ">$i\n";
        }    
    print "</SELECT>\n";
}

sub select_make($$)
{
    (my $name, my @what) = @_;
    print "<SELECT NAME=$name>";
    for (my $i=0; $i<@what; $i++) {
        print "<OPTION VALUE=$i" . (($i==$currentmonth) ? " SELECTED" : "") . ">$what[$i]";
        }    
    print "</SELECT>\n";
}

sub select_zone($$$)
{
    (my $dbh, my $name, my $currentzone) = @_;
    print "<SELECT NAME=$name>";
    if ( $currentzone eq 'NONE' )
	{ print "<OPTION VALUE=0>      "; }
    my $sth1;
    eval {$sth1 = $dbh->prepare("SELECT * FROM Zone ORDER BY OrderNum");$sth1->execute();};
    if ($@) {print "$lang{GENERAL_ERROR_SHORT} $@";}
    while (my $ref1 = $sth1->fetchrow_hashref()) {
        print "<OPTION VALUE=$ref1->{'ID'}" . (($ref1->{'Name'} eq $currentzone) ? " SELECTED" : "") . ">$ref1->{'Name'}";
        }    
    print "</SELECT>\n";
    $sth1->finish();
}

sub select_router($$$)
{
    (my $dbh, my $name, my $currentrout) = @_;
    print "<SELECT NAME=$name>";

    my $sth1;
    eval {$sth1 = $dbh->prepare("SELECT * FROM Routers ORDER BY Name");$sth1->execute();};
    if ($@) {print "$lang{GENERAL_ERROR_SHORT} $@";}
    while (my $ref1 = $sth1->fetchrow_hashref()) {
        print "<OPTION VALUE=$ref1->{'ID'}" . (($ref1->{'Name'} eq $currentrout) ? " SELECTED" : "") . ">$ref1->{'Name'}";
        }    
    print "</SELECT>\n";
    $sth1->finish();
    undef $sth1; undef $ref1;
}

sub select_swich($$$)
{
    (my $dbh, my $name, my $currentswich) = @_;
    print "<SELECT NAME=$name>";

    my $sth1;
    eval {$sth1 = $dbh->prepare("SELECT * FROM Swiches ORDER BY Name");$sth1->execute();};
    if ($@) {print "$lang{GENERAL_ERROR_SHORT} $@";}
    while (my $ref1 = $sth1->fetchrow_hashref()) {
        print "<OPTION VALUE=$ref1->{'ID'}" . (($ref1->{'Name'} eq $currentswich) ? " SELECTED" : "") . ">$ref1->{'Name'}";
        }    
    print "</SELECT>\n";
    $sth1->finish();
    undef $sth1; undef $ref1;
}

sub select_net($$$)
{
    (my $dbh, my $name, my $currentnet) = @_;
    print "<SELECT NAME=$name>";
    print "<OPTION VALUE=24" . (("24" eq $currentnet) ? " SELECTED" : "") . ">24";
    print "<OPTION VALUE=25" . (("25" eq $currentnet) ? " SELECTED" : "") . ">25";
    print "</SELECT>\n";
}

sub clearbase($$$$$)
{
    (my $dbh, my $id, my $ip, my $mask, my $dip) = @_;
    eval { $dbh->do("DELETE FROM Client WHERE ID=$id") };
    if ($@) {print "<FONT color=red>Ooooohhhh....($@).</FONT><br>"};
    eval { $dbh->do("DELETE FROM User WHERE Client_ID=$id") };
    if ($@) {print "<FONT color=red>Ooooohhhh....($@).</FONT><br>"};    
    eval { $dbh->do("DELETE FROM Traffic WHERE Client_ID=$id") };
    if ($@) {print "<FONT color=red>Ooooohhhh....($@).</FONT><br>"};    
    eval { $dbh->do("DELETE FROM Income WHERE Client_ID=$id") };
    if ($@) {print "<FONT color=red>Ooooohhhh....($@).</FONT><br>"};    
    eval { $dbh->do("DELETE FROM Outlay WHERE Client_ID=$id") };
    if ($@) {print "<FONT color=red>Ooooohhhh....($@).</FONT><br>"};    
    eval { $dbh->do("DELETE FROM ClientIP WHERE Client_ID=$id") };
    if ($@) {print "<FONT color=red>Ooooohhhh....($@).</FONT><br>"};    
    eval { $dbh->do("DELETE FROM SwPorts WHERE Client_ID=$id") };
    if ($@) {print "<FONT color=red>Ooooohhhh....($@).</FONT><br>"};    
    $segment=Net::CIDR::addrandmask2cidr($ip, $mask);
    @range = Net::CIDR::cidr2range($segment);
    ($q1, $q2 ) = split(/\-/, $range[0]);
    $msk = ipstr2num($mask);
    $sth = $dbh->prepare("SELECT ID,Used,DefIP,FirstIP,LastIP FROM SubNets WHERE Mask=$msk AND FirstIP='$q1' AND LastIP='$q2' AND DefIP='$dip' ");
    $sth->execute();
    if ($@) { print "<FONT color=red>$lang{GENERAL_ERROR_SHORT} $@</FONT>"; }
    $ref = $sth->fetchrow_hashref();
    $sth->finish();
    if ( $ref->{'Used'} == 1 )
        {
        eval { $dbh->do("DELETE FROM SubNets WHERE ID=$ref->{'ID'}") };
        if ($@) {print "<FONT color=red>Ooooohhhh....($@).</FONT><br>"};
        }
    if ( $ref->{'Used'} > 1 )
        { $dbh->do("UPDATE SubNets SET Used=Used-1 WHERE ID=$ref->{'ID'}"); }
}

sub timezation($$$$$$$$$$$$)
{
    (my $dbh, my $whatis, my $ZID, my $IP, my $ID, my $Rid, my $Sid, my $sday, my $smon, my $syear, my $shour, my $smin) = @_;

    my $time = timelocal(0, $smin, $shour, $sday, $smon-1, $syear);
    my $sth;
    eval { $sth = $dbh->prepare("INSERT INTO Works VALUES (0,$time,$whatis,$Rid,$Sid,$ID,$ZID,'$IP' )"); $sth->execute(); };
    if ($@) { print "<FONT color=red>     ($@).</FONT><br>"; };
    $sth->finish();
}

#     
sub get_money($$$$$)
{
    (my $dbh, my $cid, my $sum, my $descr, my $cancredit) = @_;
    eval { $dbh->do("UPDATE Client SET Credit=(Credit-$sum) WHERE ID=$cid"); };
    if ($@) {print "<FONT color=red>    ($@).</FONT><br>";log_msg("    ($@).");return;};
    #   
    eval { $dbh->do("INSERT INTO Outlay VALUES ($cid,NOW(),$sum,'$descr')"); };
    if ($@) {print "<FONT color=red>     ($@).</FONT><br>"; log_msg("     ($@).");};
    #  ,           
    my $sth;
    eval { $sth=$dbh->prepare("SELECT IP,ZONEID,RID,SWID,Credit FROM Client WHERE ID=$cid");$sth->execute(); };
    if ($@) {print "<FONT color=red>     ($@).</FONT><br>"; log_msg("     ($@).");};
    my $ref=$sth->fetchrow_hashref();
    if (($ref->{'Credit'} <= 0) && !$cancredit)
	{
#	$dbh->do("UPDATE Client SET Active=0 WHERE ID=$cid");
	#      
	log_user_event($dbh, $cid, "  -  ");
	(my $sec,my $min,my $hour,my $mday,my $mon,my $year,my $wday,my $yday,my $isdst) = localtime(time);
	$mon++;
	$year += 1900;
	($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst) = localtime(timelocal($sec, $min, $hour, $mday, $mon-1, $year)+3600);
	$mon++;
	$year += 1900;
	timezation($dbh, 0, $ref->{'ZONEID'}, $ref->{'IP'}, $cid, $ref->{'RID'}, $ref->{'SWID'}, $mday, $mon, $year, $hour, $min);
	}
    if ($@) { print "<FONT color=red>  : $@</FONT>";}
}

sub check_referer()
{
    my $referer = $ENV{"HTTP_REFERER"};
    my $realstate = $spath_url;
#print "$referer, $realstate";
    if ( index ($referer, $realstate) < 0 )
        {
	print "<META HTTP-EQUIV=\"Refresh\" CONTENT=\"0;URL=/admin/index.html\">\n";
        exit;
        }
}

sub make_user_data ($$)
{
    (my $login, my $password) = @_;
    #   (      )
    my @login = ( $login, $password );
    my $n = 0;
    foreach $lgn (@login)
        {
        $lgn =~ tr/+/ /;
        $lgn =~ s/&/&/gi;
        $lgn =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
        @login[$n]= $lgn;
        $n++;
        }
    my $pcr = md5_base64(@login[1]);
    return ($pcr);
}

sub autorization ($$$$$$$)
{
    (my $dbh, my $login, my $password, my @strings) = @_;
    my @login = ( $login, $password );
    my $n = 0;
    my $res = '';
    foreach $lgn (@login)
    {
    $lgn =~ tr/+/ /;
    $lgn =~ s/&/&/gi;
    $lgn =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
    @login[$n]= $lgn;
    $n++;
    }
    my $sth = $dbh->prepare("SELECT Login,Passw FROM Users WHERE Login='@login[0]' ");
    $sth->execute();
    my $ref = $sth->fetchrow_hashref();
    $sth->finish();

    if ( defined $ref->{'Passw'})
        {
        my $pass = $ref->{'Passw'};
        my $pcr = md5_base64(@login[1]);
        my $auth;
        if ( $pass eq $pcr )
            {
            foreach $strings (@strings)
                {
                foreach $cr (split("", $strings))
                    { $auth+= ord($cr); }
                }
            $res = $ref->{'Login'}.':'.crypt($auth, $pass);
            return $res;
            }
        else
            { return (0); }
        }
    else
        { return 0; }
}

sub usercheck ($$)
{
    (my $dbh, my $login) = @_;
    my $pass;
    my $pcs;
    my $auth;
    my $totaltime;
    my @pairs;
    my $sth;
    my $ref;
    my $query;
    my $dopsec = $ENV{"HTTP_ACCEPT"};
    if ( lc($securetype) eq 'base' )
	{ $dopsec = ''; }
    $sth = $dbh->prepare("SELECT * FROM Users WHERE Login='$login' ");
    $sth->execute();
    $ref = $sth->fetchrow_hashref();
    $sth->finish();

    if ( defined $ref->{'Passw'})
        { $pass = $ref->{'Passw'}; }
    if (open $HASH, "tmp/$login")
        {
        $pcs= <$HASH>;
        close $HASH;
        @pairs = split (/\:/, $pcs);
        @numZ= ($ENV{"REMOTE_ADDR"}, $ENV{"HTTP_USER_AGENT"}, $ENV{"HTTP_ACCEPT_LANGUAGE"}, $ENV{"HTTP_X_FORWARDED_FOR"}, $ENV{"HTTP_ACCEPT_ENCODING"}, $ENV{"HTTP_ACCEPT_CHARSET"}, $dopsec);
        foreach $numZ (@numZ)
            {
            foreach $p (split("", $numZ))
                { $auth+= ord($p); }
            }
        if ( $pairs[1] eq crypt($auth, $pass))
            {
            if ( $pairs[2] == 0 )
                { return $ref->{'Status'}; }
            $totaltime = time - $pairs[2];
            if ( $totaltime > $user_timeout )
                {
                $query = "UPDATE Users SET LastActive=$pairs[2] WHERE Login='$login' ";
                eval { $dbh->do($query) };
                if ($@) {print "<FONT color=red>  :<br>$@.<br>    .</FONT><br>";}
                unlink ("tmp/$login");
                return -1;
                }
            else
                {
                $totaltime = $login.':'.$pairs[1].':'.time;
                open (HASH, "> tmp/$login");
                print HASH $totaltime;
                close (HASH);
                return $ref->{'Status'};
                }
            }
        else
            {return -1; }
        }
    else
        { return -1; }
    return -1;
}

sub authorized ($$)
{
    (my $dbh, my $login) = @_;

    my $totaltime; my @timedata; my $sth; my $ref;
    print "<META HTTP-EQUIV=\"Refresh\" CONTENT=\"2;URL=/cgi-bin/admin/index.pl?Action=''&user=$login\">\n";
    print "<div align=center><table border='0' width=800 height=300>\n";
    print "<tr><td align=center>$lang{AUTHORIZED_WELCOME}, $ref->{'AFam'} $ref->{'AName'} $ref->{'AOtc'}\n";
    $sth = $dbh->prepare("SELECT LastActive FROM Users WHERE Login='$login' ");
    $sth->execute();
    $ref = $sth->fetchrow_hashref();
    $sth->finish();
    $totaltime = $ref->{'LastActive'};
    (my $sec, my $min, my $hour, my $mday, my $mon, my $year, my $wday, my $yday, my$isdst) = localtime($totaltime);
    $mon++;
    $year+=1900;
    print "<p>$lang{AUTHORIZED_LASTDATE} $mday/$mon/$year $hour:$min:$sec  </td></tr>\n";
    print "<tr><td align=center><a href=/cgi-bin/admin/index.pl?Action=''&user=$login>$lang{AUTHORIZED_WAITFOR}</a></td></tr>\n";
    print "</table></div>\n";
    exit;
}

sub not_authorized()
{
print "<META HTTP-EQUIV=\"Refresh\" CONTENT=\"4;URL=/cgi-bin/index.html\">\n";
print "<div align=center><table border='0' width=800 height=300>\n";
print "<tr><td align=center><h2><font color='#FF0000'>$lang{NO_AUTHORIZED}</font></h2></td></tr>\n";
print "</table></div>\n";
exit;
}


sub online_users($$$$)
{
    (my $dbh, my $activeuser, my $status, my $login) = @_;
    my @list;
    my $pcs; my $n = 0; my $tr = 0; my $sth; my $ref;
    my @pairs; my $color = '#333333';
    my $totaltime;
    
    if ( !defined($login))
        {
        opendir (USR, "tmp/");
        @list = readdir(USR);
        closedir(USR);
        print "<table border='0'><tr><td>$lang{USER_LIST_WHO}:</td><td>\n";
        foreach my $user ( @list )
            {
            if ( $user ne '.' && $user ne '..' )
                {
                if (open $HASH, "tmp/$user")
                    {
                    $pcs= <$HASH>;
                    close $HASH;
                    @pairs = split (/\:/, $pcs);
                    $totaltime = time - $pairs[2];
                    if ( $totaltime < $user_timeout )
                        {
                        (my $sec, my $min, my $hour, my $mday, my $mon, my $year, my $wday, my $yday, my$isdst) = localtime($pairs[2]);
                        $mon++;
                        $hour = sprintf ( "%02d", $hour);
                        $min = sprintf ( "%02d", $min);
                        $year+=1900;
                        $sth = $dbh->prepare("SELECT ID,Status FROM Users WHERE Login='$user' ");
                        $sth->execute();
                        $ref = $sth->fetchrow_hashref();
                        $sth->finish();
                        if ( $ref->{'Status'} == 1 )
                            { $color = '#0000FF'; }
                        elsif ( $ref->{'Status'} == 2 )
                            { $color = '#FF3399'; }
                        elsif ( $ref->{'Status'} > 2 )
                            { $color = '#FF0000'; }
                        $list[$n] = "<A href=$spath_users\?Action=show&ID=$ref->{'ID'}&user=".$activeuser." class=atbl title='".$lang{USER_LIST_DATE}.': '.$mday.' '.$monthrnames[$mon].' '.$year.' '.$hour.':'.$min."'><font color=\'$color\'>".$user."</font>, \n";
                        print "$list[$n]";
                        $n++;
                        }
                    }
                }
            $n++;
            }
        print "</td></tr></table>\n";
        }
    elsif ( defined ($login))
        {
        if (open $HASH, "tmp/$login")
            {
            $pcs= <$HASH>;
            close $HASH;
            @pairs = split (/\:/, $pcs);
            (my $sec, my $min, my $hour, my $mday, my $mon, my $year, my $wday, my $yday, my$isdst) = localtime($pairs[2]);
            $mon++;
            $year+=1900;
            $hour = sprintf ( "%02d", $hour);
            $min = sprintf ( "%02d", $min);
            return ( $mday.' '.$monthrnames[$mon].' '.$year.' '.$hour.':'.$min );
            }
        else
            {
            $sth = $dbh->prepare("SELECT LastActive FROM Users WHERE Login='$login' ");
            $sth->execute();
            $ref = $sth->fetchrow_hashref();
            $sth->finish();
            (my $sec, my $min, my $hour, my $mday, my $mon, my $year, my $wday, my $yday, my$isdst) = localtime($ref->{'LastActive'});
            $mon++;
            $year+=1900;
            $hour = sprintf ( "%02d", $hour);
            $min = sprintf ( "%02d", $min);
            return ( $mday.' '.$monthrnames[$mon].' '.$year.' '.$hour.':'."$min" );
            }
        }
}

sub add_file($$$)
{
    (my $path, my $file, my $afile) = @_;
    
    $path .= '/'.$afile;
    if (not sysopen FILE, $path, O_EXCL | O_CREAT | O_WRONLY, 0444)
        { print "Error!"; }
    binmode FILE;
    while (read($file, my $block, 524288))
        { print FILE $block; }
    close FILE;
}
					
sub image_size($$$$)
{
    (my $imageindb, my $realpath, my $maxx, my $maxy) = @_;
    
    my $x = $maxx; my $y = $maxy; my $res = 'width="'.$x.'" height="'.$y.'"';
    my @file = split (/\//, $imageindb);
    $file[@file-1] = $realpath.$file[@file-1];
    ($x, $y) = imgsize("$file[@file-1]");
    if ( $x == 0 || $y == 0)
	{
        $res = 'width="'.$maxx.'" height="'.$maxy.'"';
        return $res;
        }
    my $z=$y/$x;
    if ( $x > $maxx || $y > $maxy )
        { $x = $maxx; $y = int ($x*$z); }
    $res = 'width="'.$x.'" height="'.$y.'"';
    return $res;
}

sub check_client_valid($$$$$$$$)
{
    (my $dbh, my $cip, my $cidrmask, my $segment, my $firstip, my $lastip, my $cdip, my $cmask) = @_;

    @range = split (/\./, $firstip);
    @range1 = split (/\./, $lastip);
    ( $q1, $q2, $q3, $q4) = split(/\./, $cdip );

    if ( ( $q4 > $range[3] && $q4 < $range1[3] ) || $cidrmask eq '255.255.255.255' )
        {;}
    else
        { print "<center><FONT color=red><b>$lang{NETS_ERROR_DEFBAD}</FONT></b><br></center>\n"; exit;}
    ( $q1, $q2, $q3, $q4) = split(/\./, $cip );
    if ( ( $q4 > $range[3] && $q4 < $range1[3] ) || $cidrmask eq '255.255.255.255' )
        {;}
    else
        { print "<center><FONT color=red><b>$lang{NETS_ERROR_IPBAD}</FONT></b><br></center>\n"; exit;}
    $sth = $dbh->prepare("SELECT ID,FirstIP,LastIP FROM Nets WHERE NET LIKE '".$q1.'.'.$q2.'.'.$q3.'%'."' ");
    $sth->execute();
    if ($@) { print "<FONT color=red>$lang{GENERAL_ERROR_SHORT} $@</FONT>"; }
    $octet = $q4;
    my $NetID = -1;
    while ($ref = $sth->fetchrow_hashref())
        {
        ( $q1, $q2, $q3, $q4) = split(/\./, $ref->{'FirstIP'} );
        ( $q1_, $q2_, $q3_, $q4_) = split(/\./, $ref->{'LastIP'} );
        if ( $octet > $q4 && $octet < $q4_ )
            { $NetID = $ref->{'ID'}; }
        }
    $sth->finish();
    $sth = $dbh->prepare("SELECT ID,FirstIP,LastIP FROM SubNets WHERE NetID=$NetID ");
    $sth->execute();
    if ($@) { print "<FONT color=red>$lang{GENERAL_ERROR_SHORT} $@</FONT>"; }
    while ($ref = $sth->fetchrow_hashref())
        {
        ( $q1, $q2, $q3, $q4) = split(/\./, $ref->{'FirstIP'} );
        ( $q1_, $q2_, $q3_, $q4_) = split(/\./, $ref->{'LastIP'} );
        if ( $octet > $q4 && $octet < $q4_ )
            {
            if ( $q4 != $range[3] || $q4_ != $range1[3] )
                { print "<center><FONT color=red><b>$lang{NETS_ERROR_NETINNET}</FONT></b><br></center>\n"; $sth->finish(); exit;}
            }
        if ( $q4 == $range[3] || $q4_ == $range1[3] )
            {
            if ( $q4 != $range[3] && $q4_ != $range1[3] )
                { print "<center><FONT color=red><b>$lang{NETS_ERROR_NETINNET}</FONT></b><br></center>\n"; $sth->finish(); exit;}
            }
        if ( $q4 > $range[3] && $q4_ < $range1[3] )
            { print "<center><FONT color=red><b>$lang{NETS_ERROR_NETINNET}</FONT></b><br></center>\n"; $sth->finish(); exit;}
        }
    $sth->finish();
    if ( $NetID == -1 )
        { print "<center><FONT color=red><b>$lang{NETS_ERROR_NETS}</FONT></b><br></center>\n"; exit;}
    ( $q1, $q2 ) = split(/\//, $segment );
    $sth = $dbh->prepare("SELECT DefIP,Mask FROM SubNets WHERE NET='$q1' ORDER by SortN");
    $sth->execute();
    if ($@) { print "<FONT color=red>$lang{GENERAL_ERROR_SHORT} $@</FONT>"; }
    $ref = $sth->fetchrow_hashref();
    my $netmarker = 0;
    #    ?
    if ( !$ref->{'Mask'} && !$ref->{'DefIP'} )
        { $netmarker = 1; }
    #      
    if ( $ref->{'Mask'} != $cmask && $netmarker == 0 )
        { print "<center><FONT color=red><b>$lang{NETS_ERROR_MASK}</FONT></b><br></center>\n"; exit;}
    #    1   .
    if ( length ($ref->{'DefIP'}) > 6 && $ref->{'DefIP'} ne $cdip && $netmarker == 0 )
        { print "<center><FONT color=red><b>$lang{NETS_ERROR_DEF}</FONT></b><br></center>\n"; exit;}
    my $result = $netmarker.';'.$NetID;
    return $result;
}

sub StatTable($$$)
{
(my $dbh, my $sid, my $port) = @_;
my $n = 0; my $q = 0; my @split; my $sth; my $ref; my $sth1; my $ref1;
my $now = time - 86400;
(my $sec, my $min, my $hour, my $dm, my $mon, my $year, my $wday, my $yday, my $isdst) = localtime($now); 
$min = (int($min/10))*10;
$now = timelocal($sec, $min, $hour, $dm, $mon, $year);
my @times;
my $last = time;
my @data; my $maxup = 0; my $maxdown = 0;

if ( index($port, '/') >= 0 )
    {
    @split = split(/\//, $port);
    $port = $split[1];
    }

$q = 0;
for ( $n = $now; $n < $last; $n+=600 )
    { $times[$q++] = $n; }

my $firstdown; my $firstup;
$sth = $dbh->prepare("SELECT MAX(U) caco FROM PortData WHERE Swich_ID=$sid AND Port=$port AND U<=$now");
$sth->execute();
$ref = $sth->fetchrow_hashref();
$firstup = $ref->{'caco'};
$sth = $dbh->prepare("SELECT MAX(D) coco FROM PortData WHERE Swich_ID=$sid AND Port=$port AND D<=$now");
$sth->execute();
$ref = $sth->fetchrow_hashref();
$firstdown = $ref->{'coco'};
$sth->finish();

if ( $firstdown < $firstup )
    {
    for ( $n = 0; $n < $q; $n++ )
	{ $data[$n] = '#00FF00'; }
    }
if ( $firstdown > $firstup )
    {
    for ( $n = 0; $n < $q; $n++ )
	{ $data[$n] = '#FF0000'; }
    }
    
my $z = 0; my $v = 0; my $x; my $respr;
$sth = $dbh->prepare("SELECT * FROM PortData WHERE U>=$now AND U<=$last AND Swich_ID=$sid AND Port=$port ORDER by ID");
$sth->execute();
if ($@) { print "<FONT color=red>$lang{GENERAL_ERROR_SHORT} $@</FONT>"; }
while (my $ref = $sth->fetchrow_hashref())
    {
    if ( $ref->{'U'} == 0 )
	{ next; }
    $x = int(($ref->{'U'}-$now)/600);
    $respr = $ref->{'U'} - $times[$x];
    $respr = $respr/6;
    if ( $respr <= 33 )
	{ $data[$x] = '#FF4856'; }
    elsif ( $respr > 33 && $respr <= 67 )
	{ $data[$x] = '#FE858E'; }
    elsif ( $respr > 67 && $respr <= 100 )
	{ $data[$x] = '#FFD7DB'; }
    $sth1 = $dbh->prepare("SELECT MIN(D) caco FROM PortData WHERE D>$ref->{'U'} AND D<=$last AND Swich_ID=$sid AND Port=$port");
    $sth1->execute();
    $ref1 = $sth1->fetchrow_hashref();
    $v = int(($ref1->{'caco'}-$now)/600);
    $sth1->finish();
    for ( $x+=1; $x <=$v; $x++)
        {
	$data[$x] = '#00FF00';
        }
    $z++;
    }
$sth->finish();
$z = 0; $v = 0;
$sth = $dbh->prepare("SELECT * FROM PortData WHERE D>=$now AND D<=$last AND Swich_ID=$sid AND Port=$port ORDER BY ID");
$sth->execute();
if ($@) { print "<FONT color=red>$lang{GENERAL_ERROR_SHORT} $@</FONT>"; }
while (my $ref = $sth->fetchrow_hashref())
    {
    if ( $ref->{'D'} == 0 )
	{ next; }
    $x = int(($ref->{'D'}-$now)/600);
    $respr = $ref->{'D'} - $times[$x];
    $respr = $respr/6;
    if ( $respr <= 33 )
	{ $data[$x] = '#FFD7DB'; }
    elsif ( $respr > 33 && $respr <= 67 )
	{ $data[$x] = '#FE858E'; }
    elsif ( $respr > 67 && $respr <= 99 )
	{ $data[$x] = '#FF4856'; }
    $sth1 = $dbh->prepare("SELECT MIN(U) caco FROM PortData WHERE U>$ref->{'D'} AND U<=$last AND Swich_ID=$sid AND Port=$port");
    $sth1->execute();
    $ref1 = $sth1->fetchrow_hashref();
    $v = int(($ref1->{'caco'}-$now)/600);
    $sth1->finish();
    for ( $x+=1; $x <= $v; $x++)
        {
	if ( $data[$x] eq '#FFD7DB' || $data[$x] eq '#FE858E' || $data[$x] eq '#FF4856' )
	    { last; }
	else
	    { $data[$x] = '#FF0000'; }
        }
    $z++;
    }
$sth->finish();

$z = 0; $v = 0;
$sth = $dbh->prepare("SELECT MAX(U) coco, MAX(D) caco FROM PortData WHERE Swich_ID=$sid AND Port=$port");
$sth->execute();
$ref = $sth->fetchrow_hashref();
if ( $ref->{'coco'} > $ref->{'caco'} && $ref->{'coco'} >= $now )
    {
    $x = int(($ref->{'coco'}-$now)/600);
    $respr = $ref->{'coco'} - $times[$x];
    $respr = $respr/6;
    if ( $respr <= 33 )
	{ $data[$x] = '#FFD7DB'; }
    elsif ( $respr > 33 && $respr <= 67 )
	{ $data[$x] = '#FE858E'; }
    elsif ( $respr > 67 && $respr <= 99 )
	{ $data[$x] = '#FF4856'; }
    for ( $x += 1; $x <= @times; $x++)
	{ $data[$x] = '#00FF00'; }
    }
if ( $ref->{'coco'} < $ref->{'caco'}  && $ref->{'caco'} >= $now )
    {
    $x = int(($ref->{'caco'}-$now)/600);
    $respr = $ref->{'caco'} - $times[$x];
    $respr = $respr/6;
    if ( $respr <= 33 )
	{ $data[$x] = '#FFD7DB'; }
    elsif ( $respr > 33 && $respr <= 67 )
	{ $data[$x] = '#FE858E'; }
    elsif ( $respr > 67 && $respr <= 99 )
	{ $data[$x] = '#FF4856'; }
    for ( $x += 1; $x <= @times; $x++)
	{ $data[$x] = '#FF0000'; }
    }
$sth->finish();


my $z = 0; my @Tline;
print "<table width=100% style='border-width: 4px;' border=1><tr>\n";

$mon+=1;
#my $firstdate = $dm.'/'.$mon.' '.$hour.':'.$min;
my $firstdate = $hour.':'.$min;
$x = $min/10;
my $y = $x+1; $v = 6;
($sec, $min, $hour, $dm, $mon, $year, $wday, $yday, $isdst) = localtime($last);
my $lastdate = $hour.':'.$min;

for ( $n = 0; $n <= 24; $n++ )
    {
    (my $sec, my $min, my $hour, my $dm, my $mon, my $year, my $wday, my $yday, my $isdst) = localtime($times[$z]); 
    $mon+=1;
    print "<td bgcolor=#000000>";
    if ( $n == 0 )
	{
	if ( $x < 1 )
	    { $Tline[$n] = $firstdate.'-'.$hour.':59'; }
	else
	    { $Tline[$n] = '&nbsp;'; }
	}
    if ( $n > 0 && $n < 24 )
	{ $Tline[$n] = $hour.':'.$min.'-'.$hour.':59'; }
    if ( $n == 24)
        {
	if ( $y > 5 )
	    { $Tline[$n] = $hour.':00-'.$lastdate; }
	else
	    { $Tline[$n] = '&nbsp;'; }
	$v = $y;
	}

    print "<table width=100% border=0><tr>\n";
    for ( $q = $x; $q < $v; $q++ )
	{
	print "<td style='font-family: Tahoma; font-size: 6px;' bgcolor=$data[$z++]>&nbsp";
	print "</td>\n";
	$x = 0;
	}
    print "</tr>\n</table>\n";
    print "</td>\n";
    }
print "</tr>\n";
print "<tr>\n";
for ( $n = 0; $n <= 24; $n++ )
    { print "<td style='font-family: Arial, Helvetica, sans-serif; font-size: 8px;' bgcolor=#000000><b><font color='#FFFFFF'>$Tline[$n]</font></b></td>\n"; }
print "</tr>\n";
print "</table>\n"
}
